Index: /XIOS/trunk/bld.cfg
===================================================================
--- /XIOS/trunk/bld.cfg	(revision 1703)
+++ /XIOS/trunk/bld.cfg	(revision 1704)
@@ -46,10 +46,11 @@
 #bld::target test_remap.exe
 bld::target xios_server.exe 
+bld::target generic_testcase.exe 
 #bld::target test_regular.exe
 #bld::target test_xios2_cmip6.exe
 #bld::target test_new_features.exe test_unstruct_complete.exe 
-#bld::target test_remap.exe
-#bld::target test_complete.exe
-#bld::target test_client.exe
+bld::target test_remap.exe
+bld::target test_complete.exe
+bld::target test_client.exe
 #bld::target test_unstruct_complete.exe
 #bld::target test_unstructured.exe
Index: /XIOS/trunk/src/attribute.hpp
===================================================================
--- /XIOS/trunk/src/attribute.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute.hpp	(revision 1704)
@@ -42,4 +42,5 @@
             virtual void fromString(const StdString & str) = 0;
             virtual StdString dump(void) const = 0;
+            virtual StdString dump4graph(void) const = 0;
             virtual bool isEqual(const CAttribute& ) = 0;
 
Index: /XIOS/trunk/src/attribute_array.hpp
===================================================================
--- /XIOS/trunk/src/attribute_array.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_array.hpp	(revision 1704)
@@ -56,4 +56,5 @@
             virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer); }
             virtual string dump(void) const { return _dump();}
+            virtual string dump4graph(void) const { return _dump4graph();}
 
             virtual void generateCInterface(ostream& oss,const string& className) ;
@@ -71,4 +72,5 @@
           StdString _toString(void) const;
           StdString _dump(void) const;
+          StdString _dump4graph(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: /XIOS/trunk/src/attribute_array_impl.hpp
===================================================================
--- /XIOS/trunk/src/attribute_array_impl.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_array_impl.hpp	(revision 1704)
@@ -138,4 +138,13 @@
     }
 
+    template <typename T_numtype, int N_rank>
+    StdString CAttributeArray<T_numtype,N_rank>::_dump4graph(void) const
+    {
+      StdOStringStream oss;
+      if (! isEmpty() && this->hasId() && (this->numElements()!=0))
+        oss << this->getName() << "=" << CArray<T_numtype, N_rank>::dump() << "";
+      return (oss.str());
+    }
+
 
       template <typename T_numtype, int N_rank>
Index: /XIOS/trunk/src/attribute_enum.hpp
===================================================================
--- /XIOS/trunk/src/attribute_enum.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_enum.hpp	(revision 1704)
@@ -63,4 +63,5 @@
             virtual void fromString(const StdString & str) { if (str==resetInheritanceStr) { reset(); _canInherite=false ;}  else _fromString(str);}
             virtual StdString dump(void) const { return _toString();}
+            virtual StdString dump4graph(void) const { return _dump4graph();}
 
             virtual bool toBuffer  (CBufferOut& buffer) const { return _toBuffer(buffer);} 
@@ -79,4 +80,5 @@
           bool isEqual_(const CAttributeEnum& attr );
           StdString _toString(void) const;
+          StdString _dump4graph(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: /XIOS/trunk/src/attribute_enum_impl.hpp
===================================================================
--- /XIOS/trunk/src/attribute_enum_impl.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_enum_impl.hpp	(revision 1704)
@@ -149,4 +149,13 @@
   }
 
+template <class T>
+  StdString CAttributeEnum<T>::_dump4graph(void) const
+  {
+     StdOStringStream oss;
+     if (!CEnum<T>::isEmpty() && this->hasId())
+        oss << this->getName() << "=" << CEnum<T>::toString() << "</br>";
+     return (oss.str());
+  }
+
   template <class T>
   void CAttributeEnum<T>::_fromString(const StdString & str)
Index: /XIOS/trunk/src/attribute_map.cpp
===================================================================
--- /XIOS/trunk/src/attribute_map.cpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_map.cpp	(revision 1704)
@@ -48,4 +48,31 @@
             {
               str.append(att.second->dump());
+              str.append(" ");
+            }
+            else if (str.length() == maxNbChar)
+            {
+              str.append("...");
+            }
+          }
+        }
+        return str;
+      }
+
+
+
+      StdString CAttributeMap::record4graphXiosAttributes(void) const
+      {
+        int maxNbChar = 250;
+        StdString str;
+        typedef std::pair<StdString, CAttribute*> StdStrAttPair;
+        auto it = SuperClassMap::begin(), end = SuperClassMap::end();
+        for (; it != end; it++)
+        {
+          const StdStrAttPair& att = *it;
+          if (!att.second->isEmpty())
+          {
+            if (str.length() < maxNbChar)
+            {
+              str.append(att.second->dump4graph());
               str.append(" ");
             }
Index: /XIOS/trunk/src/attribute_map.hpp
===================================================================
--- /XIOS/trunk/src/attribute_map.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_map.hpp	(revision 1704)
@@ -39,4 +39,5 @@
             void clearAllAttributes(void);
             StdString dumpXiosAttributes(void) const;
+            StdString record4graphXiosAttributes(void) const;
 
             void clearAttribute(const StdString& key);
Index: /XIOS/trunk/src/attribute_template.hpp
===================================================================
--- /XIOS/trunk/src/attribute_template.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_template.hpp	(revision 1704)
@@ -75,4 +75,5 @@
 //            virtual void fromBinary(StdIStream & is);
             virtual StdString dump(void) const { return _dump();}
+            virtual StdString dump4graph(void) const { return _dump4graph();}
 
             virtual bool toBuffer  (CBufferOut& buffer) const { return _toBuffer(buffer);}
@@ -100,4 +101,5 @@
           StdString _toString(void) const;
           StdString _dump(void) const;
+          StdString _dump4graph(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: /XIOS/trunk/src/attribute_template_impl.hpp
===================================================================
--- /XIOS/trunk/src/attribute_template_impl.hpp	(revision 1703)
+++ /XIOS/trunk/src/attribute_template_impl.hpp	(revision 1704)
@@ -208,4 +208,13 @@
          if (!CType<T>::isEmpty() && this->hasId())
             oss << this->getName() << "=\"" << CType<T>::dump() << "\"";
+         return (oss.str());
+      }
+
+      template <class T>
+         StdString CAttributeTemplate<T>::_dump4graph(void) const
+      {
+         StdOStringStream oss;
+         if (!CType<T>::isEmpty() && this->hasId())
+            oss << this->getName() << "=" << CType<T>::dump() << "</br>";
          return (oss.str());
       }
Index: /XIOS/trunk/src/config/field_attribute.conf
===================================================================
--- /XIOS/trunk/src/config/field_attribute.conf	(revision 1703)
+++ /XIOS/trunk/src/config/field_attribute.conf	(revision 1704)
@@ -40,2 +40,7 @@
 DECLARE_ATTRIBUTE(StdString, cell_methods)
 DECLARE_ENUM4(cell_methods_mode,  overwrite, prefix, suffix, none)
+
+
+DECLARE_ATTRIBUTE(bool,      build_workflow_graph)
+DECLARE_ATTRIBUTE(CDuration, build_workflow_graph_start)
+DECLARE_ATTRIBUTE(CDuration, build_workflow_graph_end)
Index: /XIOS/trunk/src/cxios.cpp
===================================================================
--- /XIOS/trunk/src/cxios.cpp	(revision 1703)
+++ /XIOS/trunk/src/cxios.cpp	(revision 1704)
@@ -11,4 +11,6 @@
 #include "memtrack.hpp"
 #include "registry.hpp"
+
+#include "graphviz.hpp"
 
 namespace xios
@@ -135,4 +137,5 @@
        globalRegistry->toFile("xios_registry.bin") ;
        delete globalRegistry ;
+       CGraphviz::buildWorkflowGraphVisjs_with_info();
      }
 
Index: /XIOS/trunk/src/filter/binary_arithmetic_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/binary_arithmetic_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/binary_arithmetic_filter.cpp	(revision 1704)
@@ -1,3 +1,7 @@
 #include "binary_arithmetic_filter.hpp"
+#include "workflow_graph.hpp"
+#include "yacc_var.hpp"
+#include "file.hpp"
+
 
 namespace xios
@@ -7,5 +11,67 @@
     , op(operatorExpr.getOpScalarField(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+  };
+
+  std::tuple<int, int, int> CScalarFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = true;
+    int unique_filter_id;
+    bool firstround;
+
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      // not first round
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
+
 
   CDataPacketPtr CScalarFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -16,4 +82,12 @@
     packet->status = data[0]->status;
 
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(value, data[0]->data));
@@ -26,5 +100,66 @@
     , op(operatorExpr.getOpFieldScalar(op))
     , value(value)
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+  };
+
+  std::tuple<int, int, int> CFieldScalarArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = true;
+    int unique_filter_id;
+    bool firstround;
+
+    if(building_graph)
+    {
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+      }
+      // not first round
+      else 
+      {
+        firstround=false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldScalarArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -35,4 +170,12 @@
     packet->status = data[0]->status;
 
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+
+    packet->field = this->field;
+
     if (packet->status == CDataPacket::NO_ERROR)
       packet->data.reference(op(data[0]->data, value));
@@ -44,5 +187,83 @@
     : CFilter(gc, 2, this)
     , op(operatorExpr.getOpFieldField(op))
-  { /* Nothing to do */ };
+  { 
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
+  };
+
+  std::tuple<int, int, int> CFieldFieldArithmeticFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? ((data[0]->timestamp >= this->field->field_graph_start && data[0]->timestamp <= this->field->field_graph_end) && (data[0]->timestamp == data[1]->timestamp)) : false;
+
+    int unique_filter_id;
+
+    bool firstround;
+
+    if(building_graph)
+    {  
+      CWorkflowGraph::allocNodeEdge();
+
+      // std::cout<<"CFieldFieldArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        firstround = true;
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
+      }
+      // not first round
+      else 
+      {
+        firstround = false;
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
+    }
+
+    return std::make_tuple(building_graph, firstround, unique_filter_id);
+  }
 
   CDataPacketPtr CFieldFieldArithmeticFilter::apply(std::vector<CDataPacketPtr> data)
@@ -51,4 +272,13 @@
     packet->date = data[0]->date;
     packet->timestamp = data[0]->timestamp;
+
+    std::tuple<int, int, int> graph = buildGraph(data);
+
+    if(std::get<0>(graph)) packet->src_filterID = std::get<2>(graph);
+    if(std::get<0>(graph) && std::get<1>(graph)) packet->distance = data[0]->distance+1;
+    if(std::get<0>(graph) && !std::get<1>(graph)) packet->distance = data[0]->distance;
+    
+    packet->field = this->field;
+    
 
     if (data[0]->status != CDataPacket::NO_ERROR)
@@ -64,3 +294,9 @@
     return packet;
   }
+
+  StdString CScalarFieldArithmeticFilter::GetName(void)    { return StdString("CScalarFieldArithmeticFilter"); }
+  StdString CFieldScalarArithmeticFilter::GetName(void)    { return StdString("CFieldScalarArithmeticFilter"); }
+  StdString CFieldFieldArithmeticFilter::GetName(void)     { return StdString("CFieldFieldArithmeticFilter"); }
+
+
 } // namespace xios
Index: /XIOS/trunk/src/filter/binary_arithmetic_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/binary_arithmetic_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/binary_arithmetic_filter.hpp	(revision 1704)
@@ -6,4 +6,5 @@
 #include "operator_expr.hpp"
 #include <unordered_map>
+#include <tuple>
 
 namespace xios
@@ -23,4 +24,6 @@
        */
       CScalarFieldArithmeticFilter(CGarbageCollector& gc, const std::string& op, double value);
+      StdString virtual GetName(void);
+
 
     protected:
@@ -35,4 +38,7 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
+      
+
   }; // class CScalarFieldArithmeticFilter
 
@@ -51,4 +57,6 @@
        */
       CFieldScalarArithmeticFilter(CGarbageCollector& gc, const std::string& op, double value);
+      StdString virtual GetName(void);
+
 
     protected:
@@ -63,4 +71,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldScalarArithmeticFilter
 
@@ -78,4 +87,6 @@
        */
       CFieldFieldArithmeticFilter(CGarbageCollector& gc, const std::string& op);
+      StdString virtual GetName(void);
+
 
     protected:
@@ -89,4 +100,5 @@
        */
       CDataPacketPtr virtual apply(std::vector<CDataPacketPtr> data);
+      std::tuple<int, int, int> virtual buildGraph(std::vector<CDataPacketPtr> data);
   }; // class CFieldFieldArithmeticFilter
 } // namespace xios
Index: /XIOS/trunk/src/filter/data_packet.hpp
===================================================================
--- /XIOS/trunk/src/filter/data_packet.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/data_packet.hpp	(revision 1704)
@@ -9,4 +9,5 @@
 namespace xios
 {
+  class CField;
   /*!
    * A packet corresponds to a timestamped array of data.
@@ -26,5 +27,9 @@
     Time timestamp;         //!< Timestamp of the data
     StatusCode status;      //!< Status of the packet
-
+    int src_filterID;
+    std::vector<int> filterIDoutputs;
+    CField *field;
+    int distance;
+    
     /*!
      * Creates a deep copy of the packet.
Index: /XIOS/trunk/src/filter/file_writer_filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/file_writer_filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/file_writer_filter.cpp	(revision 1704)
@@ -3,4 +3,6 @@
 #include "field.hpp"
 #include "utils.hpp"
+#include "workflow_graph.hpp"
+#include "graphviz.hpp"
 
 namespace xios
@@ -15,6 +17,40 @@
   }
 
+  void CFileWriterFilter::buildGraph(std::vector<CDataPacketPtr> data)
+  {
+    bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph: false;
+    
+    if(building_graph)
+    {
+      this->filterID = InvalidableObject::filterIdGenerator++;
+      int edgeID = InvalidableObject::edgeIdGenerator++;
+
+      CWorkflowGraph::allocNodeEdge();
+      StdString namestring = to_string(this->field->name);
+      namestring.erase(0, 6);
+      namestring.erase(namestring.length()-1, 1);
+
+      CWorkflowGraph::addNode(this->filterID, namestring + "\\n("+this->field->file->getId()+".nc)", 6, 0, 1, data[0]);
+
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->record4graphXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->record4graphXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].clusterID =1;
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].distance = data[0]->distance+1;
+
+      if(CXios::isClient && CWorkflowGraph::build_begin) 
+      {
+
+        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+      }
+      else CWorkflowGraph::build_begin=true;
+    }
+  }
+
   void CFileWriterFilter::onInputReady(std::vector<CDataPacketPtr> data)
   {
+    buildGraph(data);
+    
     const bool detectMissingValue = ( !field->default_value.isEmpty() &&
                                ( (!field->detect_missing_value.isEmpty() || field->detect_missing_value == true)
Index: /XIOS/trunk/src/filter/file_writer_filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/file_writer_filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/file_writer_filter.hpp	(revision 1704)
@@ -3,4 +3,6 @@
 
 #include "input_pin.hpp"
+#include "file.hpp"
+#include "duration.hpp"
 
 namespace xios
@@ -14,4 +16,11 @@
   {
     public:
+      int tag;
+      Time start_graph;
+      Time end_graph;
+      CField* field; //<! The associated field
+      int filterID;
+      int distance;
+
       /*!
        * Constructs the filter (with one input slot) associated to the specified field
@@ -22,4 +31,7 @@
        */
       CFileWriterFilter(CGarbageCollector& gc, CField* field);
+
+      inline StdString GetName(void) {return "File writer filter";};
+
 
       /*!
@@ -44,7 +56,7 @@
        */
       void virtual onInputReady(std::vector<CDataPacketPtr> data);
+      void virtual buildGraph(std::vector<CDataPacketPtr> data);
 
     private:
-      CField* field; //<! The associated field
       std::map<Time, CDataPacketPtr> packets; //<! The stored packets
   }; // class CFileWriterFilter
Index: /XIOS/trunk/src/filter/filter.cpp
===================================================================
--- /XIOS/trunk/src/filter/filter.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/filter.cpp	(revision 1704)
@@ -5,8 +5,10 @@
   CFilter::CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine)
     : CInputPin(gc, inputSlotsCount)
-    , COutputPin(gc)
+    , COutputPin(gc, false)
     , engine(engine)
     , inputSlotCount(inputSlotCount)
   { /* Nothing to do */ }
+
+  StdString CFilter::GetName(void)    { return StdString("Filter"); }
 
   void CFilter::onInputReady(std::vector<CDataPacketPtr> data)
Index: /XIOS/trunk/src/filter/filter.hpp
===================================================================
--- /XIOS/trunk/src/filter/filter.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/filter.hpp	(revision 1704)
@@ -25,4 +25,6 @@
        */
       CFilter(CGarbageCollector& gc, size_t inputSlotsCount, IFilterEngine* engine);
+
+      StdString virtual GetName(void);
 
       /*!
@@ -62,4 +64,10 @@
       bool virtual isDataExpected(const CDate& date) const;
 
+      
+      
+
+      int filterID;
+      StdString expression;
+
     protected:
       IFilterEngine* engine; //!< The filter engine, might be the filter itself
Index: /XIOS/trunk/src/filter/garbage_collector.cpp
===================================================================
--- /XIOS/trunk/src/filter/garbage_collector.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/garbage_collector.cpp	(revision 1704)
@@ -3,4 +3,10 @@
 namespace xios
 {
+  int InvalidableObject::filterIdGenerator = 0;
+
+  int InvalidableObject::edgeIdGenerator = 0;
+
+  int InvalidableObject::clusterIdGenerator = 0;
+  
   void CGarbageCollector::registerObject(InvalidableObject* Object, Time timestamp)
   {
Index: /XIOS/trunk/src/filter/garbage_collector.hpp
===================================================================
--- /XIOS/trunk/src/filter/garbage_collector.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/garbage_collector.hpp	(revision 1704)
@@ -20,4 +20,15 @@
      */
     void virtual invalidate(Time timestamp) = 0;
+  
+    
+
+    static int filterIdGenerator;
+
+    static int edgeIdGenerator;
+
+    static int clusterIdGenerator;
+
+    
+    
   }; // struct InvalidableObject
 
Index: /XIOS/trunk/src/filter/input_pin.cpp
===================================================================
--- /XIOS/trunk/src/filter/input_pin.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/input_pin.cpp	(revision 1704)
@@ -3,4 +3,5 @@
 #include "garbage_collector.hpp"
 #include "exception.hpp"
+#include "workflow_graph.hpp"
 
 namespace xios
@@ -11,5 +12,10 @@
     , triggers(slotsCount)
     , hasTriggers(false)
-  { /* Nothing to do */ }
+  {  }
+
+  StdString CInputPin::GetName(void)
+  {
+    return StdString("Input pin");
+  }
 
   void CInputPin::setInput(size_t inputSlot, CDataPacketPtr packet)
Index: /XIOS/trunk/src/filter/input_pin.hpp
===================================================================
--- /XIOS/trunk/src/filter/input_pin.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/input_pin.hpp	(revision 1704)
@@ -26,4 +26,6 @@
        */
       CInputPin(CGarbageCollector& gc, size_t slotsCount);
+      
+      StdString virtual GetName(void);
 
       /*!
Index: /XIOS/trunk/src/filter/output_pin.cpp
===================================================================
--- /XIOS/trunk/src/filter/output_pin.cpp	(revision 1703)
+++ /XIOS/trunk/src/filter/output_pin.cpp	(revision 1704)
@@ -1,4 +1,5 @@
 #include "output_pin.hpp"
 #include "exception.hpp"
+#include "workflow_graph.hpp"
 
 namespace xios
@@ -7,5 +8,10 @@
     : gc(gc)
     , manualTrigger(manualTrigger)
-  { /* Nothing to do */ }
+  {  }
+
+  StdString COutputPin::GetName(void)
+  {
+    return StdString("Output pin");
+  }
 
   void COutputPin::connectOutput(std::shared_ptr<CInputPin> inputPin, size_t inputSlot)
@@ -101,3 +107,25 @@
     outputPackets.erase(outputPackets.begin(), outputPackets.lower_bound(timestamp));
   }
+
+  void COutputPin::setParentFiltersTag()
+  {
+    for(int i=0; i<parent_filters.size(); i++)
+    {
+
+      if(parent_filters[i]->start_graph<0) parent_filters[i]->start_graph = start_graph;
+      else parent_filters[i]->start_graph = min(parent_filters[i]->start_graph, start_graph);
+
+
+      if(parent_filters[i]->end_graph<0) parent_filters[i]->end_graph = end_graph;  
+      else parent_filters[i]->end_graph = max(parent_filters[i]->end_graph, end_graph);
+      
+      
+      parent_filters[i]->tag += tag;
+      parent_filters[i]->setParentFiltersTag();
+    }
+  }
+
+
+
+
 } // namespace xios
Index: /XIOS/trunk/src/filter/output_pin.hpp
===================================================================
--- /XIOS/trunk/src/filter/output_pin.hpp	(revision 1703)
+++ /XIOS/trunk/src/filter/output_pin.hpp	(revision 1704)
@@ -4,7 +4,12 @@
 #include "garbage_collector.hpp"
 #include "input_pin.hpp"
+#include "duration.hpp"
 
 namespace xios
 {
+  class CField;
+  class CInputPin;
+  class CFilter;
+  class CDuration;
   /*!
    * An output pin handles the connections with downstream filters.
@@ -13,4 +18,14 @@
   {
     public:
+      int tag;
+      Time start_graph;
+      Time end_graph;
+      CField *field;
+      int distance;
+
+
+
+      std::vector< std::shared_ptr<COutputPin> > parent_filters;
+
       /*!
        * Constructs an ouput pin with manual or automatic trigger
@@ -22,4 +37,6 @@
       COutputPin(CGarbageCollector& gc, bool manualTrigger = false);
 
+      StdString virtual GetName(void);
+      
       /*!
        * Connects to a specific slot of the input pin of a downstream filter.
@@ -66,4 +83,7 @@
       void virtual invalidate(Time timestamp);
 
+      void virtual setParentFiltersTag();
+
+
     protected:
       /*!
